using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;

namespace WindowsApplication8
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private GridRangeInfoList wholeSelectedRows = new GridRangeInfoList();
        private GridRangeInfoList cannotSelectCells = new GridRangeInfoList();
        private void Form1_Load(object sender, EventArgs e)
        {
            this.gridControl1.AllowSelection = GridSelectionFlags.Any;

            this.gridControl1.ExcelLikeCurrentCell = true; //so cuurentcell is part of selection


            //use this event to prevent selections...
            this.gridControl1.SelectionChanging += new GridSelectionChangingEventHandler(gridControl1_SelectionChanging);

            //use this event to force selections
            this.gridControl1.SelectionChanged += new GridSelectionChangedEventHandler(gridControl1_SelectionChanged);

            //require an entire row - row 3 & 7 must be selected as entire row
            wholeSelectedRows.Add(GridRangeInfo.Row(3));
            wholeSelectedRows.Add(GridRangeInfo.Row(7));
            //color them so you can see them
            gridControl1.RowStyles[3].BackColor = Color.LightYellow;
            gridControl1.RowStyles[7].BackColor = Color.LightYellow;

            cannotSelectCells.Add(GridRangeInfo.Cell(2, 2));
            cannotSelectCells.Add(GridRangeInfo.Cell(2, 4));
            cannotSelectCells.Add(GridRangeInfo.Cell(5, 3));
            //color them so you can see them
            gridControl1[2, 2].BackColor = Color.LightPink;
            gridControl1[2, 4].BackColor = Color.LightPink;
            gridControl1[5, 3].BackColor = Color.LightPink;

            //cells that cannot get focus
            gridControl1[8, 3].Enabled = false;
            gridControl1[9, 4].Enabled = false;
            //also make them so they cannot be drag-selected
            cannotSelectCells.Add(GridRangeInfo.Cell(8, 3));
            cannotSelectCells.Add(GridRangeInfo.Cell(9, 4));
            //color them so you can see them
            gridControl1[8, 3].BackColor = Color.LightGray;
            gridControl1[9, 4].BackColor = Color.LightGray;
        }

        void gridControl1_SelectionChanged(object sender, GridSelectionChangedEventArgs e)
        {
            if (e.Range != null && !e.Range.IsEmpty && e.Reason == GridSelectionReason.MouseUp)
            {
                bool refreshNeeded = false;
                foreach (GridRangeInfo range in wholeSelectedRows)
                {
                    if (e.Range.IntersectsWith(range) && !e.Range.Contains(range))
                    {
                        gridControl1.Selections.SelectRange(range, true); //extend selection to whole row
                        refreshNeeded = true;
                    }
                }
                if (refreshNeeded)
                    gridControl1.Refresh();
                
            }
        }

        void gridControl1_SelectionChanging(object sender, GridSelectionChangingEventArgs e)
        {
     
            if (e.Range != null && !e.Range.IsEmpty)
            {
                   foreach (GridRangeInfo range in cannotSelectCells)
                {
                    if (e.Range.IntersectsWith(range))
                    {
                        e.Cancel = true; //do not allow selection
                    }
                }
            }
        }
    }
}